
#include <Stepper.h>
  int switchOneVal = LOW;
  int switchTwoVal = LOW;
  int switchThreeVal = LOW;
  int switchFourVal = LOW;
  int switchFiveVal = LOW;
  int switchSixVal = LOW;
  int switchSevenVal = LOW;
  int switchEightVal = LOW;
  int switchNineVal = LOW;
  int switchTenVal = LOW;  
  
  int stepperSpeed =10;
  float val = 510;
  float smallVal = 205;
  String totalVal= "";
  int totalValInt=0;
  int i=0;
  int multiplierLarge = 2;
  int multiplierSmall = 1;
  
// change this to the number of steps on your motor
#define STEPS 200

// create an instance of the stepper class, specifying
// the number of steps of the motor and the pins it's
// attached to
Stepper stepperA(STEPS,12,9,11,10);
Stepper stepperB(STEPS,8,5,7,6);
Stepper stepperC(STEPS,A1,A3,A0,A2);
Stepper stepperD(STEPS,A5,A7,A4,A6);
Stepper stepperNULL(STEPS,22,23,24,25);

// the previous reading from the analog input
int previous = 0;

void setup() 
{
   pinMode(39, INPUT_PULLUP);
   pinMode(38, INPUT_PULLUP);
   pinMode(37, INPUT_PULLUP);
   pinMode(36, INPUT_PULLUP);
   pinMode(35, INPUT_PULLUP);
   pinMode(34, INPUT_PULLUP);
   pinMode(33, INPUT_PULLUP);
   pinMode(32, INPUT_PULLUP);
   pinMode(31, INPUT_PULLUP);  
   pinMode(13,OUTPUT);
   
  // set the speed of the motor to 30 RPMs
  
   stepperA.setSpeed(50);
   stepperB.setSpeed(50);
   stepperC.setSpeed(50);  
   stepperD.setSpeed(50); 
   stepperNULL.setSpeed(100);    
    Serial.begin(115200); 
}

void loop() 
{
  stepperSpeed = analogRead(8)/4;                    // Max speed = 250
  if(stepperSpeed<5){stepperSpeed=5;}                // Prevents motor from turning too slowly
  // Turns all the motors off if no button is pressed:
  if((switchOneVal==HIGH)&&(switchTwoVal==HIGH)&&(switchThreeVal==HIGH)&&(switchFourVal==HIGH))
  {
  digitalWrite(12,LOW);
  digitalWrite(11,LOW);
  digitalWrite(10,LOW);
  digitalWrite(9,LOW);
  digitalWrite(8,LOW);
  digitalWrite(7,LOW);
  digitalWrite(6,LOW);
  digitalWrite(A0,LOW);
  digitalWrite(A1,LOW);
  digitalWrite(A2,LOW);
  digitalWrite(A3,LOW);
  digitalWrite(A4,LOW);
  digitalWrite(A5,LOW);
  digitalWrite(A6,LOW);
  digitalWrite(A7,LOW);
  }
  
  if((switchOneVal==LOW)||(switchTwoVal==LOW)||(switchThreeVal==LOW)||(switchFourVal==LOW)||(switchFiveVal==LOW))
  {digitalWrite(13,HIGH);}
  else{digitalWrite(13,LOW);}
  
  switchOneVal = digitalRead(39);
  switchTwoVal = digitalRead(38);
  switchThreeVal = digitalRead(32);
  switchFourVal = digitalRead(33);
     
  switchFiveVal = digitalRead(36);
  
//  switchSixVal = digitalRead(30); 
//  switchSevenVal = digitalRead(33); 
//  switchEightVal = digitalRead(32); 

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if (switchFiveVal==LOW)
  {   
  sampling();
//  stepperNULL.step(totalValInt-previous); 
  previous = totalValInt;
  Serial.print("Switch 5 pressed:  ");Serial.println(totalValInt);
  }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if (switchOneVal==LOW)
  {   
  stepperA.setSpeed(stepperSpeed);  
  sampling();
  stepperA.step(totalValInt-previous); 
  previous = totalValInt;
  }
  else {stepperA.setSpeed(1);}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if (switchTwoVal==LOW)
  { 
  stepperB.setSpeed(stepperSpeed);   
  sampling();
  stepperB.step(totalValInt-previous); 
  previous = totalValInt;
  }
  else {stepperB.setSpeed(1);}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if (switchThreeVal==LOW)
  {   
  stepperC.setSpeed(stepperSpeed); 
  sampling();
  stepperC.step(totalValInt-previous); 
  previous = totalValInt;
  }  
  else {stepperC.setSpeed(1);}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if (switchFourVal==LOW)
  {  
  stepperD.setSpeed(stepperSpeed); 
  sampling();
  stepperD.step(totalValInt-previous); 
  previous = totalValInt;
  }
  else {stepperD.setSpeed(1);}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}
void sampling()    //Oversample the slider readings to avoid motor vibration.
{
   i=0;
   val =0;
   smallVal=0;
while(i<100)
{ 
  val = analogRead(14)*multiplierLarge +val;
  smallVal = analogRead(15)*multiplierSmall +smallVal;  
  i++;
}
  val=val/i;
  smallVal=smallVal/i;
  totalVal=val+smallVal; 
  totalValInt=totalVal.toInt();   
}
